image: python:3.7
stages:
  - test
  - check
  - package

services:
  - postgres:12

variables:
  POSTGRES_DB: project_ci_test
  POSTGRES_USER: odoo
  POSTGRES_PASSWORD: "odoo"
  TEST_DBNAME: '${CI_PROJECT_PATH_SLUG}-pipeline-${CI_PIPELINE_ID}'
  DEPLOY_DBNAME: '${CI_PROJECT_PATH_SLUG}-${CI_COMMIT_REF_SLUG}'
  RUNNER_HOME: '/home/gitlab-runner'
  INSTANCE_PATH: '${RUNNER_HOME}/instances/${CI_PROJECT_PATH_SLUG}-${CI_COMMIT_REF_SLUG}'
  TRAVIS_BUILD_DIR: "$CI_PROJECT_DIR"
  VERSION: "12.0"
  ODOO_BRANCH: "12.0_2021-04-29"
  ODOO_REPO: "coopdevs/ocb"
  REPO_PLATFORM: "gitlab"
  CODECOV_TOKEN: '${CODECOV_TOKEN}'
  MQT_DEP: "pip"


before_script:
  - curl -sL https://deb.nodesource.com/setup_10.x | bash -
  - apt-get install -y  sudo postgresql-client expect-dev python3-lxml nodejs python-dev python3-pip build-essential libsasl2-dev python-dev libldap2-dev libssl-dev libxmlsec1-dev npm
  - pip install coverage

lint:
  stage: test
  tags:
    - postgres
    - docker
  variables:
    LINT_CHECK: "1"
    TESTS: "0"
  script:
    # We need to export the PG* here, otherwise the postgresql container
    # Wil pick them up
    - export PGHOST="postgres"
    - export PGUSER="odoo"
    - export PGPASSWORD="odoo"
    - git clone https://github.com/coopdevs/maintainer-quality-tools.git -b feature/show-pylint-errors ${HOME}/maintainer-quality-tools
    - export PATH=${HOME}/maintainer-quality-tools/travis:${HOME}/gitlab_tools:${PATH}
    - travis_install_nightly
    - travis_run_tests
    - travis_after_tests_success || true

# TODO

# test:
#   stage: test
#   tags:
#     - postgres
#     - docker
#   variables:
#     LINT_CHECK: "0"
#     TESTS: "1"
#   script:
#     # We need to export the PG* here, otherwise the postgresql container
#     # Wil pick them up
#     - export PGHOST="postgres"
#     - export PGUSER="odoo"
#     - export PGPASSWORD="odoo"
#     - git clone https://github.com/coopdevs/maintainer-quality-tools.git -b feature/use-pip-install-deps ${HOME}/maintainer-quality-tools
#     - export PATH=${HOME}/maintainer-quality-tools/travis:${HOME}/gitlab_tools:${PATH}
#     - travis_install_nightly
#     - cd /root/ocb-12.0 && python setup.py install && cd -
#     - travis_run_tests
#     - travis_after_tests_success || true
#     # Related with https://about.codecov.io/security-update/
#     - echo "Downloading and checking the Codecov Bash upload script"
#     - curl -s https://codecov.io/bash > codecov;
#     - VERSION=$(grep 'VERSION=\".*\"' codecov | cut -d'"' -f2);
#     - for i in 1 256 512; do shasum -a $i -c --ignore-missing <(curl -s https://raw.githubusercontent.com/codecov/codecov-bash/${VERSION}/SHA${i}SUM); done
#     - bash codecov -t ${CODECOV_TOKEN}
#   coverage: '/TOTAL.+ ([0-9]{1,3}%)/'

# check_coverage:
#   stage: check
#   tags:
#     - docker
#   variables:
#     JOB_NAME: "test"
#   before_script:
#     - apt-get update -qq && apt-get install -y -qq jq
#   script:
#     - CURRENT_COVERAGE=`curl -s "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/pipelines/${CI_PIPELINE_ID}/jobs" | jq --arg JOB_NAME "$JOB_NAME" '.[] | select(.name==$JOB_NAME) | .coverage'`
#     - if  [ "$CURRENT_COVERAGE" -lt "$MIN_COVERAGE" ]; then echo "Coverage decreased from ${MIN_COVERAGE}. Current value ${CURRENT_COVERAGE}" && exit 1; fi;

publish:
  stage: package
  script:
    - pip install twine wheel setuptools-odoo
    - echo 'Building Source and Wheel (universal) distribution…'
    - cd setup/somconnexio
    - python setup.py sdist bdist_wheel --universal
    - echo 'Uploading the package to PyPI via Twine…'
    - twine upload dist/*
  artifacts:
    paths:
      - setup/somconnexio/dist/
  rules:
    - if: $CI_COMMIT_TAG
